from base.url.url_view_model import UrlViewModel
from base.url.url_preview import UrlPreview
from blackfennec.interpretation.interpretation import Interpretation
from blackfennec.interpretation.specification import Specification
from blackfennec.presentation_system.type_view_factory import TypeViewFactory


class UrlViewFactory(TypeViewFactory):
    def __init__(self, ui_service) -> None:
        super().__init__()
        self._ui_service = ui_service

    def satisfies(self, specification: Specification) -> bool:
        return specification.is_request_for_preview

    def create(self, interpretation: Interpretation) -> UrlPreview:
        view_model = UrlViewModel(interpretation)
        return UrlPreview(view_model, self._ui_service)
