from blackfennec.util.change_notification_dispatch_mixin import ChangeNotificationDispatchMixin


class UrlViewModel(ChangeNotificationDispatchMixin):
    def __init__(self, interpretation):
        super().__init__()

        self._url_string = interpretation.structure
        self._url_string.bind(changed=self._dispatch_change_notification)

    @property
    def url(self) -> str:
        """Property for url"""
        return self._url_string.value

    @url.setter
    def url(self, url: str):
        # prevent event loop
        if url == self.url:
            return
        self._url_string.value = url
