import pytest

from blackfennec_doubles.interpretation.double_interpretation import InterpretationMock
from blackfennec_doubles.structure.double_map import MapMock
from blackfennec_doubles.structure.double_string import StringMock
from blackfennec_doubles.document_system.double_document_registry import DocumentRegistryMock
from base.url.url_view_model import UrlViewModel


@pytest.fixture
def url():
    return StringMock('https://blackfennec.org')


@pytest.fixture
def interpretation(url):
    return InterpretationMock(url)


@pytest.fixture
def view_model(interpretation):
    return UrlViewModel(interpretation)


def test_can_construct(view_model):
    assert view_model


def test_can_get_url(view_model):
    assert view_model.url == 'https://blackfennec.org'


def test_can_set_url(view_model):
    view_model.url = 'https://blackfennec.org/new_url'
    assert view_model.url == 'https://blackfennec.org/new_url'


def test_does_not_set_url_twice(view_model):
    view_model.url = 'https://blackfennec.org'
